ctdb cannot create PID file

Bug #1821775 reported by Robert Sander on 2019-03-26
26
This bug affects 3 people
Affects Status Importance Assigned to Milestone
samba (Ubuntu)
Status tracked in Eoan
Bionic
Medium
Rafael David Tinoco
Cosmic
Medium
Rafael David Tinoco
Disco
Medium
Rafael David Tinoco
Eoan
Medium
Rafael David Tinoco

Bug Description

[Impact]

 * LP: #722201 - SAMBA CTDB cluster suite does not work for High Available NFS setups
 * LP: #1821775 - ctdb cannot create PID file
 * LP: #1828799 - Package ctdb does not create directories in /var/lib/ctdb

[Test Case]

 * Installing CTDB and trying to start the service (check /var/log/ctdb/ctdb.log):
   - no /etc/ctdb/nodes file, can't start
   - /var/lib/ctdb/volatile does not exist
   - and some other errors addressed in here

[Regression Potential]

 * very small chances of causing issues to other parts of samba
 * ctdb app is placed in a specific directory and is not working nowadays

[Other Info]

 * Documentation on how to enable this SRU: https://discourse.ubuntu.com/t/ctdb-create-a-3-node-nfs-ha-backed-by-a-clustered-filesystem/11608

ORIGINAL DESCRIPTION:

With the default installation on Ubuntu 19.04 ctdb does not start as it cannot create its PID file:

2019/03/26 17:01:26.377449 ctdbd[530]: CTDB starting on node
2019/03/26 17:01:26.380654 ctdbd[536]: Starting CTDBD (Version 4.10.0-Ubuntu) as PID: 536
2019/03/26 17:01:26.380739 ctdbd[536]: Failed to create PID file /var/run/ctdb/ctdbd.pid

After manually creating the directory /var/run/ctdb ctdb is able to start.

Related branches

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ctdb (Ubuntu):
status: New → Confirmed
Harry Coin (hcoin) wrote :

Changed /etc/init.d/ctdb
pidfile="/var/run/ctdb/ctdbd.pid" to pidfile="/run/ctdb/ctdbd.pid"

Then

sudo systemctl edit ctdb

[Service]
ExecStartPre=/bin/mkdir -p /run/ctdb

And it will work upon reboot as well. (/run is deleted every reboot)
Still seems to be looking for /var/run in the logs though.

Changed in ctdb (Ubuntu):
importance: Undecided → Medium
assignee: nobody → Rafael David Tinoco (rafaeldtinoco)
status: Confirmed → In Progress
Changed in samba (Ubuntu):
status: New → In Progress
importance: Undecided → Medium
assignee: nobody → Rafael David Tinoco (rafaeldtinoco)
no longer affects: ctdb (Ubuntu)

The fix (Eoan) and SRU (Disco, Cosmic and Bionic) for this bug is being done at:

https://bugs.launchpad.net/ubuntu/+source/samba/+bug/722201

Changed in samba (Ubuntu Bionic):
status: New → Confirmed
Changed in samba (Ubuntu Cosmic):
status: New → Confirmed
Changed in samba (Ubuntu Disco):
status: New → In Progress
Changed in samba (Ubuntu Bionic):
importance: Undecided → Medium
Changed in samba (Ubuntu Cosmic):
importance: Undecided → Medium
Changed in samba (Ubuntu Disco):
importance: Undecided → Medium
Changed in samba (Ubuntu Bionic):
assignee: nobody → Rafael David Tinoco (rafaeldtinoco)
Changed in samba (Ubuntu Cosmic):
assignee: nobody → Rafael David Tinoco (rafaeldtinoco)
Changed in samba (Ubuntu Disco):
assignee: nobody → Rafael David Tinoco (rafaeldtinoco)
Changed in samba (Ubuntu Disco):
status: In Progress → Confirmed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package samba - 2:4.10.0+dfsg-0ubuntu5

---------------
samba (2:4.10.0+dfsg-0ubuntu5) eoan; urgency=medium

  * debian/rules: Make DEB_HOST_ARCH_CPU initialized through
    dpkg-architecture (Closes: #931138)
  * d/p/ctdb-scripts-fix-tcp_tw_recycle-existence-check.patch:
    fix tcp_tw_recycle existence check. (LP: #722201)
  * d/p/fix-nfs-service-name-to-nfs-kernel-server.patch:
    change nfs service name from nfs to nfs-kernel-server
    (LP: #722201)
  * d/ctdb.install, d/rules: create ctdb run directory into tmpfiles.d
    to allow pid file to exist (LP: #1821775)
  * Allow proper ctdb initialization (LP: #1828799):
    - d/ctdb.dirs: added /var/lib/ctdb/* directories
    - d/ctdb.postrm: remove leftovers from:
      /var/lib/ctdb/{state,persistent,volatile,scripts}
  * d/rules: installing provided config examples and helper scripts
  * Examples of NFS HA CTDB config files + helper script:
    - d/ctdb.example.enable.nfs.sh
    - d/ctdb.example.nfs-common
    - d/ctdb.example.nfs-kernel-server
    - d/ctdb.example.services
    - d/ctdb.example.sysctl-nfs-static-ports.conf
  * d/p/ctdb-config-depend-on-etc-default-nodes-file.patch:
    do not try to start daemon if /etc/ctdb/nodes does not exist
  * d/p/ctdb-config-enable-syslog-by-default.patch:
    enable syslog and systemd journal by default

 -- Rafael David Tinoco <email address hidden> Fri, 28 Jun 2019 00:14:27 +0000

Changed in samba (Ubuntu Eoan):
status: In Progress → Fix Released
Changed in samba (Ubuntu Cosmic):
status: Confirmed → Won't Fix
description: updated
Changed in samba (Ubuntu Bionic):
status: Confirmed → Won't Fix

Hello Robert, or anyone else affected,

Accepted samba into disco-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/samba/2:4.10.0+dfsg-0ubuntu2.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-disco to verification-done-disco. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-disco. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in samba (Ubuntu Disco):
status: Confirmed → Fix Committed
tags: added: verification-needed verification-needed-disco

All autopkgtests for the newly accepted samba (2:4.10.0+dfsg-0ubuntu2.3) for disco have finished running.
The following regressions have been reported in tests triggered by the package:

gvfs/1.40.1-1ubuntu0.1 (amd64)

Please visit the excuses page listed below and investigate the failures, proceeding afterwards as per the StableReleaseUpdates policy regarding autopkgtest regressions [1].

https://people.canonical.com/~ubuntu-archive/proposed-migration/disco/update_excuses.html#samba

[1] https://wiki.ubuntu.com/StableReleaseUpdates#Autopkgtest_Regressions

Thank you!

FYI - this test fail was resolved by a retry as gvfs is somewhat flaky

tags: added: verification-done verification-done-disco
removed: verification-needed verification-needed-disco
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package samba - 2:4.10.0+dfsg-0ubuntu2.3

---------------
samba (2:4.10.0+dfsg-0ubuntu2.3) disco; urgency=medium

  * CTDB enablement for NFS HA (LP: #722201) and needed fixes:
    - d/p/ctdb-config-depend-on-etc-default-nodes-file.patch: do not try to
      start daemon without /etc/ctdb/nodes.
    - d/rules: installing provided config examples and helper scripts.
    - Examples of NFS HA CTDB config files + helper script:
      + d/ctdb.example.enable.nfs.sh
      + d/ctdb.example.nfs-common
      + d/ctdb.example.nfs-kernel-server
      + d/ctdb.example.services
      + d/ctdb.example.sysctl-nfs-static-ports.conf
    - d/p/fix-nfs-service-name-to-nfs-kernel-server.patch: change nfs service
      name from nfs to nfs-kernel-server.
    - d/p/ctdb-scripts-fix-tcp_tw_recycle-existence-check.patch: fix
      tcp_tw_recycle existence check.
  * Allow proper ctdb initalization (LP: #1828799):
    - d/ctdb.dirs: added /var/lib/ctdb/* directories
    - d/ctdb.postrm: remove leftovers from
      /var/lib/ctdb/{state,persistent,volatile,scripts}
  * d/ctdb.install, d/rules: create ctdb run directory into tmpfiles.d
    to allow pid file to exist (LP: #1821775)

 -- Rafael David Tinoco <email address hidden> Thu, 11 Jul 2019 18:00:50 +0000

Changed in samba (Ubuntu Disco):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for samba has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.